from read_baseline_data import *
from read_chirp_data import *
from utility import *
#import nix_helpers as nh 
import matplotlib.pyplot as plt
import numpy as np
from IPython import embed #Funktionen imposrtieren


data_dir = "../data"
dataset = "2018-11-13-ad-invivo-1"
#data = ("2018-11-09-ad-invivo-1", "2018-11-13-aa-invivo-1", "2018-11-13-ad-invivo-1", "2018-11-09-af-invivo-1", "2018-11-09-ag-invivo-1", "2018-11-13-ah-invivo-1", "2018-11-13-ai-invivo-1", "2018-11-13-aj-invivo-1", "2018-11-13-ak-invivo-1", "2018-11-13-al-invivo-1", "2018-11-14-aa-invivo-1", "2018-11-14-ab-invivo-1", "2018-11-14-ac-invivo-1", "2018-11-14-ad-invivo-1", "2018-11-14-ae-invivo-1", "2018-11-14-af-invivo-1", "2018-11-14-ag-invivo-1", "2018-11-14-ah-invivo-1", "2018-11-14-aj-invivo-1", "2018-11-14-ak-invivo-1", "2018-11-14-al-invivo-1", "2018-11-14-am-invivo-1", "2018-11-14-an-invivo-1", "2018-11-20-aa-invivo-1", "2018-11-20-ab-invivo-1", "2018-11-20-ac-invivo-1", "2018-11-20-ad-invivo-1"," 2018-11-20-ae-invivo-1", "2018-11-20-af-invivo-1", "2018-11-20-ag-invivo-1", "2018-11-20-ah-invivo-1", "2018-11-20-ai-invivo-1") Durchgang für alle Datensets - zwischenspeichern von Daten?



spike_times = read_baseline_spikes(os.path.join(data_dir, dataset))
spike_iv = np.diff(spike_times)


x = np.arange(0.001, 0.01, 0.0001)
plt.hist(spike_iv,x)

mu = np.mean(iv)
sigma = np.std(iv)
cv = sigma/mu

plt.title('A.lepto ISI Histogramm', fontsize = 14)
plt.xlabel('duration ISI[ms]', fontsize = 12)
plt.ylabel('number of ISI', fontsize = 12)

plt.xticks(fontsize = 12)
plt.yticks(fontsize = 12)
plt.show()




#Nyquist-Theorem Plot:


chirp_spikes = read_chirp_spikes(os.path.join(data_dir, dataset))
df_map = map_keys(chirp_spikes)
sort_df = sorted(df_map.keys())

plt.figure()
dct_rate = {}
overall_r = {}
for i in sort_df:
	freq = list(df_map[i])
	dct_rate[i] = []
	overall_r[i] = []
	for k in freq:
		for phase in chirp_spikes[k]:
			spikes = chirp_spikes[k][phase]
			rate = len(spikes)/ 1.2
			dct_rate[i].append(rate)
			#overall_r[i].extend(rate) #kann man nicht erweitern!

ls_mean = []
for h in sort_df:	
	mean = np.mean(dct_rate[h])
	ls_mean.append(mean)		
	plt.plot(np.arange(0,len(dct_rate[h]),1),dct_rate[h], label = h)

#plt.vlines(10, ymin = 190, ymax = 310)
#Anfang Spur und Endpunkt bestimmen
#relativ zur mittleren Feuerrate
#wie hoch ist die Adaption von Zellen
plt.legend()
plt.title('Firing rate of the cell for all trials, sorted by df')
plt.xlabel('# of trials')
plt.ylabel('Instant firing rate of the cell')
plt.show()



#mittlere Feuerrate einer Frequenz auf Frequenz:

plt.figure()
plt.plot(np.arange(0,len(ls_mean),1),ls_mean)
#plt.scatter(np.arange(0,len(ls_mean),1), np.mean(int(overall_r)))
plt.title('Mean firing rate of a cell for a range of frequency differences')
plt. xticks(np.arange(1,len(sort_df),1), (sort_df))
plt.xlabel('Range of frequency differences [Hz]')
plt.ylabel('Mean firing rate of the cell')
plt.show()



#Boxplot 
#wie viel Prozent macht die Adaption von Zellen aus?


#Reihen-Plot
#macht die zeitliche Reihenfolge der Präsentation einen Unterschied in der Zellantwort?
